#ifndef __SQRT_C__
#define __SQRT_C__ 

int sqrtfix(int aa)
begin
    // do not change the order of these variables
    // the compiler puts them in
    // r16:17, r18, r19, r20:21
    int a;
    char nextbit, ahigh;
    int root ; 
    a = aa; 
    #asm("mov r19, r17")     //set: ahigh = a>>8
    //
    // range sort to get integer part and to
    // check for weird bits near the top of the range
    if (ahigh >= 0x40)     //bigger than 64?
    begin
        if (a > 0x7e8f)    //>=126.562 = 11.25^2
        begin
            root = 0x0b40;  // 11
            nextbit = 0x10 ;
        end 
        else if (ahigh >= 0x79)    //>=121
        begin
            root = 0x0b00;  // 11
            nextbit = 0x40 ;
        end
        else if (ahigh >= 0x64)    //>=100
        begin
            root = 0x0a00;  // 10
            nextbit = 0x80 ;
        end  
        else if (ahigh >= 0x51)    //>=81
        begin
            root = 0x0900;  // 9
            nextbit = 0x80 ;
        end 
        else   //64
        begin
            root = 0x0800;      //8
            nextbit = 0x80 ; 
        end 
    end
    else if  (ahigh >= 0x10)  //16    //smaller than 64 and bigger then 16
    begin 
        if (ahigh >= 0x31)  //49
        begin
            root = 0x0700;      //7
            nextbit = 0x80 ; 
        end
        else if (ahigh >= 0x24)  //36
        begin
            root = 0x0600;      //6
            nextbit = 0x80 ; 
        end
        else if (ahigh >= 0x19)  //25
        begin
            root = 0x0500;      //5
            nextbit = 0x80 ; 
        end   
        else //16
        begin
            root = 0x0400;      //4
            nextbit = 0x80 ; 
        end
    end  
    else       //smaller than 16
    begin 
         if (ahigh >= 0x09)  //9
        begin
            root = 0x0300;      //3
            nextbit = 0x80 ; 
        end 
        else if (ahigh >= 0x04)  //4
        begin
            root = 0x0200;      //2
            nextbit = 0x80 ; 
        end
        else if (ahigh >= 0x01)  //1
        begin
            root = 0x0100;      //1
            nextbit = 0x80 ; 
        end  
        else     //less than one
        begin
            root = 0;
            nextbit = 0x80 ;  
        end
    end
    // now get the low order bits  
    // while (nextbit)
    // begin
        #asm
        beginloop: 
        ;tst r18   ;dont need-- lsr at bottom of loop sets current SREG
        breq endit ; jumps out of loop if nextbit is zero
    	;r21:r20 contains root because of compiler trick 
    	; root = nextbit + root; 
    	add r20, r18
    	;adc r21, r19    ; dont need: never any carry
        ;
        ; p =  multfix(root,root);  
        mov r22, r20            ;load root into other mult input
        mov r23, r21
        ;
    	muls	r23, r21		; (signed)ah * (signed)bh
    	mov		r31, r0         ;r18, r0
    	mul		r22, r20		; al * bl
    	mov     r30, r1         ;movw	r17:r16, r1:r0
    	mulsu	r23, r20		; (signed)ah * bl
    	add		r30, r0         ;r17, r0
    	adc		r31, r1         ;r18, r1
    	mulsu	r21, r22		; (signed)bh * al
    	add		r30, r0         ;r17, r0
    	adc		r31, r1         ;r18, r1  
    	; p is in r30:31
    	;
    	; if (p >= a) root = root - nextbit ;
    	cp  r30, r16            ; compare root^2 with a
    	cpc r31, r17
    	brlt nosub
    	sub r20, r18            ; if r^2 >= a form r=r-nextbit
    	;sbc r21, r19           ; dont need--high byte always zero
    	nosub:
    	; nextbit = nextbit>>1 ;
    	;lsr r19                 ;shift nextbit right
    	;ror r18                  ;simplify--high byte always zero
    	lsr r18
    	rjmp beginloop
    	endit:
    	#endasm
   // end
    return root ;  
end
  
#endif //__SQRT_C__

